bufferclasses = {}

buffers = {}

def registerclass(cla):
	assert (issubclass(cla, Buffer))
	bufferclasses[cla.classname] = cla

class Buffer:
	def __init__(self, bufname):
		if buffers.has_key(bufname):
			raise ValueError, ('buffer already exists: '+bufname)

		self.name = bufname
		buffers[bufname] = self

		self.isdirty = 0
		self.filename = None
		self.watch = watcher.Watchable(self)

	def getviewclass(self):
		return window.BlankWindow

	def getcommandcontexts(self):
		return [Buffer]

	def changed(self):
		if (not self.isdirty):
			self.isdirty = 1
			self.watch.signal(watcher.SIG_MODE)

	def serialize(self, fl):
		pass
		
	def ensureopen(self):
		assert (self.name != None)
		win = window.findonebybuf(self)
		if (win == None):
			window.open(self)

	def ensureclosed(self):
		assert (self.name != None)
		win = window.findonebybuf(self)
		if (win):
			window.close(win)

	def kill(self):
		assert (self.name != None)
		ls = window.findallbybuf(self)
		if (len(ls) > 0):
			raise Exception, ('buffer still has windows open: '+self.name)
		del buffers[self.name]
		self.name = None

	def checkvalid(self):
		if (self.name == None):
			raise command.StatusBeepWarning('Buffer no longer present')
			
def findbyname(nam):
	buf = buffers.get(nam)
	if (buf == None):
		return None
	return buf
	
def getbyname(nam, cla=Buffer):
	assert issubclass(cla, Buffer)
	ix = 1
	buf = None
	while (not isinstance(buf, cla)):
		if (ix == 1):
			bufnam = nam
		else:
			bufnam = nam+'<'+str(ix)+'>'
		ix = ix+1
		buf = findbyname(bufnam)
		if (buf == None):
			buf = cla(bufnam)
	return buf

def rename(buf, nam):
	assert isinstance(buf, Buffer)
	assert (buf.name != None)
	if (buf.name == nam):
		return
	ix = 1
	while 1:
		if (ix == 1):
			bufnam = nam
		else:
			bufnam = nam+'<'+str(ix)+'>'
		ix = ix+1
		if (findbyname(bufnam) == None):
			break
	del buffers[buf.name]
	buf.name = bufnam
	buffers[buf.name] = buf

def getcompletor():
	arr = buffers.keys()
	return completion.FixedSetCompletor(arr)

def getclasscompletor():
	arr = bufferclasses.keys()
	return completion.FixedSetCompletor(arr)

# late import, to avoid circularity problems
import watcher
import window
import completion
import execute

execute.registercontext(Buffer, 'buffer')
