import command

class TextwinScrollDown(command.Command):
	"""Scroll down one page.
	"""
	name = 'textwin-scroll-down'
	context = 'textwindow'
	def call(self, win):
		if (len(win.layout)):
			pos = win.layout[0][0]
		else:
			pos = 0
		win.layout_text(pos)
		win.scrollline = win.scrollline + (win.height-2)
		win.scrollline = min(win.scrollline, 
			max(0, len(win.layout)-2))
		if (win.scrollline < len(win.layout)):
			win.scrollchar = win.layout[win.scrollline][0]
		else:
			win.scrollchar = 0
		win.dirtyview = 1

class TextwinScrollUp(command.Command):
	"""Scroll up one page.
	"""
	name = 'textwin-scroll-up'
	context = 'textwindow'
	def call(self, win):
		win.layout_text(0)
		win.scrollline = win.scrollline - (win.height-2)
		win.scrollline = max(0, win.scrollline)
		if (win.scrollline < len(win.layout)):
			win.scrollchar = win.layout[win.scrollline][0]
		else:
			win.scrollchar = 0
		win.dirtyview = 1

class TextwinScrollDownLine(command.Command):
	"""Scroll down one page.
	"""
	name = 'textwin-scroll-down-line'
	context = 'textwindow'
	def call(self, win):
		if (len(win.layout)):
			pos = win.layout[0][0]
		else:
			pos = 0
		win.layout_text(pos)
		win.scrollline = win.scrollline + 1
		win.scrollline = min(win.scrollline, 
			max(0, len(win.layout)-2))
		if (win.scrollline < len(win.layout)):
			win.scrollchar = win.layout[win.scrollline][0]
		else:
			win.scrollchar = 0
		win.dirtyview = 1

class TextwinScrollUpLine(command.Command):
	"""Scroll up one page.
	"""
	name = 'textwin-scroll-up-line'
	context = 'textwindow'
	def call(self, win):
		win.layout_text(0)
		win.scrollline = win.scrollline - 1
		win.scrollline = max(0, win.scrollline)
		if (win.scrollline < len(win.layout)):
			win.scrollchar = win.layout[win.scrollline][0]
		else:
			win.scrollchar = 0
		win.dirtyview = 1

command.register([
	TextwinScrollDown, TextwinScrollUp, 
	TextwinScrollDownLine, TextwinScrollUpLine
])

command.bind(TextwinScrollDown, '^V')
command.bind(TextwinScrollDown, 'pagedown')
command.bind(TextwinScrollUp, 'ESC v')
command.bind(TextwinScrollUp, 'pageup')
command.bind(TextwinScrollDownLine, 'down')
command.bind(TextwinScrollDownLine, '^N')
command.bind(TextwinScrollUpLine, 'up')
command.bind(TextwinScrollUpLine, '^P')

