import types
import string
import curses

contexts = {}
contextnames = {}
contextlist = []

class GlobalCommandContext:
	def getcommandcontexts(self):
		return [GlobalCommandContext]

globalcontext = GlobalCommandContext()

def registercontext(cla, label):
	if (type(cla) != types.ClassType):
		raise TypeError, 'class expected'
	label = intern(label)
	contexts[cla] = label
	contextnames[label] = cla
	contextlist.insert(0, cla)

def isregistered(cla):
	if (contexts.has_key(cla)):
		return 1
	else:
		return 0

def getcontextbyname(label):
	return contextnames.get(intern(label))

registercontext(GlobalCommandContext, 'global')

class ExecutionContext:
	perform = None
	
	def __init__(self, par):
		assert (par == None or isinstance(par, ExecutionContext))
		self.parent = par

	def getbindcontexts(self):
		ls = [globalcontext]
		win = window.getfocus()
		if (win):
			ls.insert(0, win)
			if (isinstance(win, window.Window) and win.data != None):
				ls.insert(1, win.data)
		return ls

	def perform(self, res, con, resargs, keylist):
		cmd = res(self, resargs)
		try:
			assert isinstance(con, cmd.context)
			assert (cmd.executor == self)
			cmd.call(con)
		except command.StatusWarning, ex:
			if (len(ex.args) > 0):
				st = ex.args[0]
				if (st != None):
					status.post(st)
			if (isinstance(ex, command.StatusBeepWarning)):
				curses.beep()
		
	def undefinedkey(self, keylist):
		status.post(string.join(map(command.keyname, keylist)) + ' undefined')
		curses.beep()
		#log.log(string.join(map(command.keyname, keylist)) + ' undefined\n') ###

# late import
import command
import window
import status
import log
