import types

SIG_DATA     = 1
SIG_MODE     = 2

# FOCUS? AREA? MODELINE?
# DESTROY?

# should watchers be able to register for a specific signal?

# how can we destroy a watcher?

# how to sanity-check?

class Watchable:

	def __init__(self, own):
		self.owner = own
		self.watchers = []

	def link(self, watcher, func):
		pair = (watcher, func)
		self.watchers.append(pair)

	def unlink(self, watcher):
		ls = [(wat, func) for (wat, func) in self.watchers
				if (wat != watcher)]
		self.watchers[:] = ls

	def signal(self, sig, detail=None):
		for (watcher, func) in self.watchers:
			func(self.owner, sig, detail)
